/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include "quakedef.h"

void play_mp3(unsigned char track);
void stop_mp3(void);

void CDAudio_Play(byte track, qboolean looping)
{
	play_mp3(track);
}


void CDAudio_Stop(void)
{
	stop_mp3();
}


void CDAudio_Pause(void)
{
	printf("cd pause message\n");
}


void CDAudio_Resume(void)
{
	printf("cd resume message\n");
}


void CDAudio_Update(void)
{
}


int CDAudio_Init(void)
{
	return 0;
}


void CDAudio_Shutdown(void)
{
	printf("cd shutdown message\n");
}
